// sample5.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "../lua_tinker/lua_tinker.h"

void show_error(const char* error)
{
	printf("_ALERT -> %s\n", error);
}

int _tmain(int argc, _TCHAR* argv[])
{
	// Lua  ʱȭ Ѵ.
	lua_State* L = lua_open();

	// Lua ⺻ Լ εѴ.- print() 
	luaopen_base(L);


	// lua_State*  ִ   ش.
	printf("%s\n","-------------------------- current stack");
	lua_tinker::enum_stack(L);

	// ÿ 1 оִ´.
	lua_pushnumber(L, 1);

	//    ٽ Ѵ.
	printf("%s\n","-------------------------- stack after push '1'");
	lua_tinker::enum_stack(L);


	// sample5.lua  ε/Ѵ.
	lua_tinker::dofile(L, "sample5.lua");

	// test_error() Լ ȣѴ.
	// test_error()   test_error_3() ȣ õϴ  ߻Ų.
	// Լ ȣ ߻  printf() ؼ µȴ.
	printf("%s\n","-------------------------- calling test_error()");
	lua_tinker::call<void>(L, "test_error");

	// test_error_3()  ʴ Լ̴. ȣ ü Ѵ.
	printf("%s\n","-------------------------- calling test_error_3()");
	lua_tinker::call<void>(L, "test_error_3");

	// printf()   ϴ   ƾ   ִ.
	//  ó Լ1  ڿ ߻  ϰ ȴ.
	// C++    void function(const char*) ° ϴ.
	lua_tinker::def(L, "_ALERT", show_error);

	lua_tinker::call<void>(L, "_ALERT", "test !!!");

	// test_error() Լ ȣѴ.
	// Լ ȣ ߻  Lua ϵ _ALERT() ؼ µȴ.
	printf("%s\n","-------------------------- calling test_error()");
	lua_tinker::call<void>(L, "test_error");


	// α׷ 
	lua_close(L);

	return 0;
}

